org.apache.cassandra.db.composites

## Class AbstractCType

- java.lang.Object
- - org.apache.cassandra.db.composites.AbstractCType

All Implemented Interfaces:
  java.util.Comparator<Composite>, CType

Direct Known Subclasses:
  AbstractCellNameType, CompoundCType, SimpleCType

    public abstract class AbstractCType
    extends java.lang.Object
    implements CType

### Field Summary

Fields
`protected boolean` `isByteOrderComparable`

### Constructor Summary

Constructors
`protected` `AbstractCType(boolean isByteOrderComparable)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected static void` `checkRemaining(java.nio.ByteBuffer bb, int offs, int length)`
`int` `compare(Composite c1, Composite c2)`
`DeletionInfo.Serializer` `deletionInfoSerializer()`
`boolean` `equals(java.lang.Object o)`
`protected java.util.Comparator<java.lang.Object>` `getByteOrderAsymmetricColumnComparator(boolean isRightNative)`
`protected java.util.Comparator<Cell>` `getByteOrderColumnComparator(boolean isRightNative)`
`java.lang.String` `getString(Composite c)` Converts a composite to a user-readable string.
`int` `hashCode()`
`java.util.Comparator<IndexHelper.IndexInfo>` `indexComparator()`
`java.util.Comparator<IndexHelper.IndexInfo>` `indexReverseComparator()`
`protected static boolean` `isByteOrderComparable(java.lang.Iterable<AbstractType<?>> types)`
`boolean` `isCompatibleWith(CType previous)` See AbstractType#isCompatibleWith.
`Composite` `make(java.lang.Object... components)` Convenience method to build composites from their component.
`RangeTombstone.Serializer` `rangeTombstoneSerializer()`
`java.util.Comparator<Composite>` `reverseComparator()`
`CType.Serializer` `serializer()`
`protected static java.nio.ByteBuffer` `sliceBytes(java.nio.ByteBuffer bb, int offs, int length)`
`IVersionedSerializer<SliceQueryFilter>` `sliceQueryFilterSerializer()`
`IVersionedSerializer<ColumnSlice>` `sliceSerializer()`
`java.lang.String` `toString()`
`void` `validate(Composite name)` Validates a composite.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.cassandra.db.composites.CType

`asAbstractType, builder, fromByteBuffer, isCompound, setSubtype, size, subtype`

### Methods inherited from interface java.util.Comparator

`comparing, comparing, comparingDouble, comparingInt, comparingLong, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

### Field Detail

#### isByteOrderComparable

    protected final boolean isByteOrderComparable

### Constructor Detail

#### AbstractCType

    protected AbstractCType(boolean isByteOrderComparable)

### Method Detail

#### isByteOrderComparable

    protected static boolean isByteOrderComparable(java.lang.Iterable<AbstractType<?>> types)

#### compare

    public int compare(Composite c1,
                       Composite c2)

Specified by:
  `compare` in interface `java.util.Comparator<Composite>`
Specified by:
  `compare` in interface `CType`

#### getByteOrderColumnComparator

    protected java.util.Comparator<Cell> getByteOrderColumnComparator(boolean isRightNative)

#### getByteOrderAsymmetricColumnComparator

    protected java.util.Comparator<java.lang.Object> getByteOrderAsymmetricColumnComparator(boolean isRightNative)

#### validate

    public void validate(Composite name)

Description copied from interface: `CType`
Validates a composite.

Specified by:
  `validate` in interface `CType`

#### isCompatibleWith

    public boolean isCompatibleWith(CType previous)

Description copied from interface: `CType`
See AbstractType#isCompatibleWith.

Specified by:
  `isCompatibleWith` in interface `CType`

#### getString

    public java.lang.String getString(Composite c)

Description copied from interface: `CType`
Converts a composite to a user-readable string.

Specified by:
  `getString` in interface `CType`

#### make

    public Composite make(java.lang.Object... components)

Description copied from interface: `CType`
Convenience method to build composites from their component. The arguments can be either ByteBuffer or actual objects of the type corresponding to their position.

Specified by:
  `make` in interface `CType`

#### serializer

    public CType.Serializer serializer()

Specified by:
  `serializer` in interface `CType`

#### reverseComparator

    public java.util.Comparator<Composite> reverseComparator()

Specified by:
  `reverseComparator` in interface `CType`

#### indexComparator

    public java.util.Comparator<IndexHelper.IndexInfo> indexComparator()

Specified by:
  `indexComparator` in interface `CType`

#### indexReverseComparator

    public java.util.Comparator<IndexHelper.IndexInfo> indexReverseComparator()

Specified by:
  `indexReverseComparator` in interface `CType`

#### sliceSerializer

    public IVersionedSerializer<ColumnSlice> sliceSerializer()

Specified by:
  `sliceSerializer` in interface `CType`

#### sliceQueryFilterSerializer

    public IVersionedSerializer<SliceQueryFilter> sliceQueryFilterSerializer()

Specified by:
  `sliceQueryFilterSerializer` in interface `CType`

#### deletionInfoSerializer

    public DeletionInfo.Serializer deletionInfoSerializer()

Specified by:
  `deletionInfoSerializer` in interface `CType`

#### rangeTombstoneSerializer

    public RangeTombstone.Serializer rangeTombstoneSerializer()

Specified by:
  `rangeTombstoneSerializer` in interface `CType`

#### equals

    public boolean equals(java.lang.Object o)

Specified by:
  `equals` in interface `java.util.Comparator<Composite>`
Overrides:
  `equals` in class `java.lang.Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `java.lang.Object`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### sliceBytes

    protected static java.nio.ByteBuffer sliceBytes(java.nio.ByteBuffer bb,
                                                    int offs,
                                                    int length)

#### checkRemaining

    protected static void checkRemaining(java.nio.ByteBuffer bb,
                                         int offs,
                                         int length)